--[[
******************************************************************
Licence: GPL
(c) Werner_O 2014/04/06
Thx msl
v1.03
Die Funktionen AE-Lock und LCD-Off bentigen CHDK ab Version 1.3.0
und werden gegebenenfalls automatisch deaktiviert!
******************************************************************
@title Intervall von WO
@param n Bildanzahl (0=unendlich)
@default n 20
@range n 0 10000
@param i Intervallzeit grob (sec)
@default i 3
@range i 0 1800
@param j Intervallzeit fein (100ms)
@default j 0
@range j 0 9
@param c Startverzg. grob (min)
@default c 0 
@range d c 720
@param d Startverzg. fein (sec)
@default d 2
@range d 0 60
@param l AF-/AE-Lock verwenden
@default l 0
@range l 0 1
@param f Auf Blitz warten
@default f 0
@range f 0 1
@param p Display deaktivieren
@default p 0
@range p 0 1
]]

-- Definitionen der verwendeten Variablen:
pics = n
interval = (i * 1000) + (j * 100)
delay = (c * 60000) + (d * 1000)
if l == 1 then
    aflock = 1
    aelock = 1
    shoot_mode = 1
else
    aflock = 0
    aelock = 0
    shoot_mode = 0
end
flash = f
lcd = p
ready = false
delay_counter = 0
shoot_counter = 0
message = "Uuuups..."
message2 = "Unbekannter Fehler"

-- Definitionen zu mglichen Aufnahmemodi:
modestrings = {
	'AUTO',
	'P',
	'TV',
	'AV',
	'M',
	'PORTRAIT',
	'NIGHT',
	'LANDSCAPE',
	'VIDEO_STD',
	'VIDEO_SPEED',
	'VIDEO_COMPACT',
	'VIDEO_MY_COLORS',
	'VIDEO_COLOR_ACCENT',
	'VIDEO_COLOR_SWAP',
	'STITCH',
	'MY_COLORS',
	'SCN_WATER',
	'SCN_NIGHT',
	'SCN_CHILD',
	'SCN_PARTY',
	'SCN_GRASS',
	'SCN_SNOW',
	'SCN_BEACH',
	'SCN_FIREWORK',
	'SCN_COLOR_ACCENT',
	'SCN_COLOR_SWAP',
	'VIDEO_HIRES',
	'SCN_AQUARIUM',
	'COLOR_ACCENT',
	'SCN_NIGHT1',
	'SCN_ISO_3200',
	'SCN_SPORT',
	'SCN_KIDS_PETS',
	'INDOOR',
	'KIDS_PETS',
	'NIGHT_SNAPSHOT',
	'DIGITAL_MACRO',
	'SCN_FOLIAGE',
	'VIDEO_TIME_LAPSE',
	'SCN_INDOOR',
	'SCN_PORTRAIT',
	'SUPER_MACRO',
	'VIDEO_PORTRAIT',
	'VIDEO_NIGHT',
	'VIDEO_INDOOR',
	'VIDEO_FOLIAGE',
	'VIDEO_SNOW',
	'VIDEO_BEACH',
	'VIDEO_AQUARIUM',
	'VIDEO_SUPER_MACRO',
	'VIDEO_STITCH',
	'VIDEO_MANUAL',
	'SPORTS',
}

-- Definition Unterfunktion flash_state() zur Blitzabfrage ob der Blitz bereit ist:
function flash_state()
    if get_flash_ready() == 0 then
        print("Warte auf den Blitz...")
        repeat sleep(10) until get_flash_ready() == 1
    end
end

-- Definition Unterfunktion restore() fr Skriptabbruch:
function restore()
    if aflock == 1 then set_aflock(0) end
    if aelock == 1 then set_aelock(0) end
    if shoot_mode == 1 then
        release("shoot_half")
    end
    if lcd == 1 then set_lcd_display(1) end
end

-- SYSTEMABFRAGEN FR EVTL. NTIGE KORREKTUREN:

-- Zeitnahme fr die Startverzgerung:
delay_counter = get_tick_count()

-- Setzt die Kamera in den Aufnahmemodus wenn das Skript im Wiedergabemodus gestartet wurde:
if get_mode() == false then
    print("Aktiviere Aufnahmemodus..")
    set_record(1)
    sleep(1000)
    while get_mode() == false do sleep(100) end
    print("Aufnahmemodus nun aktiv!")
end

-- berprft, ob die Kamera im Modus P, TV, AV oder M ist, da nur diese Modi zugelassen werden.
-- Ein aktivierter Video-Aufnahme-Modus fhrt ebenfalls zum Abbruch diese Skriptes:
rec,vid,mode = get_mode() 
cmode = tostring(modestrings[bitand(mode,0xFF)])
if vid == true then
   ready = false
   message = "Videoaufnahme ist aktiv,"
   message2 = "bitte erst auschalten!"
elseif cmode == "P" then
   ready = true
elseif cmode == "TV" then
   ready = true
elseif cmode == "AV" then
   ready = true
elseif cmode == "M" then
   ready = true
       if aelock == 1 then
            aelock = 0
            print("Programm M ist aktiv:")
            print("AE-L wurde deaktiviert!")
       end
   aelock = 0
else
   ready = false
   message = "Falsches Programm, bitte"
   message2 = "P, Tv, Av oder M whlen!"
end

-- ANFANG HAUPTSKRIPT MIT WEITEREN SYSTEMABFRAGEN UND KORREKTUREN:

if ready == true then
    -- Deaktiviert im MF-Modus den AF-Lock-Modus :
    if get_focus_state() < 0 then
        if aflock == 1 then
            aflock = 0
            print("Kamera ist im MF-Modus:")
            print("AF-L wurde deaktiviert!")
        end
    end
    -- Abfrage CHDK-Version; bei einer Version kleiner als 1.3.0 werden ein AE-Lock-Modus
    -- sowie ein LCD-Off mit einer Fehlermeldung deaktiviert:
    if tonumber(string.sub(string.gsub(get_buildinfo().build_number, "%p", ""), 0, 3)) < 130 then
        if aelock == 1 or lcd == 1 then
            print("CHDK < 1.3 erkannt:")
            if aelock == 1 then
                aelock = 0
                print("AE-L wurde deaktiviert!")
            end
            if lcd == 1 then
                lcd = 0
                print("Das LCD bleibt an!")
            end
            sleep(2000)
        end
    end
    -- Deaktiviert den AF-/AE-Lock-Modus bei erkannten Blitzmodi Auto oder On:
    if l == 1 then
        if get_flash_mode() < 2 then
            aelock = 0
            aflock = 0
            shoot_mode = 0
            print("Blitzmodus ist Auto/On:")
            print("AF-Lock und AE-Lock")
            print("wurde deaktiviert!")
        end
    end
    -- Deaktiviert einen aktivierten Blitzmodus, wenn der Blitz an der Kamera ausgeschaltet ist:
    if flash == 1 then
        if get_flash_mode() == 2 then
            flash = 0
            print("Blitz ist ausgeschaltet:")
            print("Blitzmodus wurde deakt.!")
        end
    end
    -- Deaktiviert einen aktivierten shoot_mode 1 wenn weder aflock noch aelock aktiviert sind: 
    if aflock == 0 and aelock == 0 then
        shoot_mode = 0
    end
    -- Ausfhren eines AF und/oder AE mit Lock vor der Intervallserie wenn aktiviert:
    if shoot_mode == 1 then
        press("shoot_half")
        repeat sleep(10) until get_shooting() == true
            if aflock == 1 then
                set_aflock(1)
            end
            if aelock == 1 then
                set_aelock(1)
            end     
    end
    -- Wartet bei aktiviertem Blitzmodus ab, bis der Blitz einsatzbereit ist:
    if flash == 1 then
        flash_state()
    end
end

-- BEGINN DER SCHLEIFE FR DIE INTERVALLAUFNAHMEN:
if ready == true then
    delay_real = delay - (get_tick_count() - delay_counter)
        if delay_real > 0 then
        print("Warte Verzgerung ab...")
        sleep(delay_real)
    end
    counter = 1
    repeat
        shoot_counter = get_tick_count()
        if shoot_mode == 0 then
            count = get_exp_count()
            shoot()
            repeat sleep(10) until get_exp_count() ~= count
        else
            count = get_exp_count()
            press("shoot_full_only")
            repeat sleep(10) until get_exp_count() ~= count
            release("shoot_full_only")
        end 
        if lcd == 1 and counter == 2 then set_lcd_display(0) end                       
        cls()
        if pics > 0 then
            print(string.format("Bild %d von %d", counter, pics))
        else
            print(string.format("Bild %d von unendlich", counter))
        end
        if flash == 1 then
            flash_state()
        end
        interval_real = interval - (get_tick_count() - shoot_counter)
        if interval_real > 0 and (counter < pics or pics == 0) then
            print("Warte Intervall ab...")
            sleep(interval_real)
        end
        counter = counter + 1
    until pics > 0 and counter > pics
    if shoot_mode == 1 then release("shoot_half") end
    if lcd == 1 then set_lcd_display(1) end
else
    print(string.format("%s", message))
    print(string.format("%s", message2))
    sleep(4000)
end

restore()